<template>
  <div
    v-if="driver.name !== 'Requêtes utilisateur'"
    class="driver-header"
    :class="driver.licenses.includes(PUBLIC_TRANSPORT_LICENSE) ? 'shuttle-driver' : 'ride-driver'"
  >
    <div class="driver">
      <div
        class="badge"
        :class="{ 'badge-active': isConnected }"
      >
        <fa-icon icon="user-circle" />
      </div>
      <div class="name">
        {{ name }}
      </div>
      <div
        v-if="capacity !== null"
        class="capacity"
      >
        <img
          src="/seat.svg"
          alt="seat-icon"
        >
        <p>{{ capacity.display }}</p>
      </div>
      <div
        v-if="displacement.car && displacement.car.model"
        class="car"
      >
        <p>
          <strong>{{ displacement.car.model.label }}</strong>
        </p>
        <p>
          {{ displacement.car.id }}
        </p>
      </div>
      <div
        v-if="capacity !== null"
        class="capacity-progress"
      >
        <div :style="{ width: `${capacity.value}%`}" />
      </div>
    </div>
    <displacement-status
      class="displacement-status"
      :displacement="displacement"
      :is-available="isAvailable"
    />
  </div>
  <div
    v-else
    class="first-col-header"
  >
    <div>Courses non attribuées</div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import { DateTime, Interval } from 'luxon';
import { CANCELED_STATUSES } from '@fabnumdef/e-chauffeur_lib-vue/api/status';
import { PUBLIC_TRANSPORT_LICENSE } from '~/helpers/driving-licenses';
import displacementStatus from '~/components/ride-status.vue';

export default {
  components: {
    displacementStatus,
  },
  props: {
    driver: {
      type: Object,
      default: () => ({}),
    },
    displacement: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return { PUBLIC_TRANSPORT_LICENSE };
  },
  computed: {
    ...mapGetters({ connectedDrivers: 'realtime/connectedDrivers' }),
    isConnected() {
      return this.connectedDrivers.reduce((acc, driverId) => acc || (driverId === this.driver.id), false);
    },
    name() {
      return `${this.driver.firstname} ${this.driver.lastname && this.driver.lastname.toUpperCase()}`;
    },
    capacity() {
      if (this.displacement.car && this.displacement.car.model && this.displacement.car.model.capacity) {
        const {
          passengersCount,
          car: { model: { capacity } },
        } = this.displacement;
        if (passengersCount) {
          return {
            value: (passengersCount / capacity) * 100,
            display: `${passengersCount}/${capacity}`,
          };
        }

        const bookedPassengers = this.displacement.passengers.filter((p) => !CANCELED_STATUSES.includes(p.status));
        return {
          value: (bookedPassengers.length / capacity) * 100,
          display: `${bookedPassengers.length}/${capacity}`,
        };
      }
      return null;
    },
    isAvailable() {
      return this.driver.availabilities.some((avail) => {
        if (typeof avail.s === 'string') {
          // eslint-disable-next-line no-param-reassign
          avail = Interval.fromDateTimes(DateTime.fromISO(avail.s), DateTime.fromISO(avail.e));
        }
        return avail.contains && avail.contains(DateTime.local());
      });
    },
  },
};
</script>

<style lang="scss" scoped>
  @import "~assets/css/head";

  .driver-header {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    height: 100%;
    border-right: 1px solid black;
    .driver {
      display: grid;
      grid-gap: .3em;
      grid-template-rows: auto 1fr auto;
      grid-template-columns: 30% 1fr;
      align-items: center;
      padding: .8em;
      .car {
        grid-column: 2 / 3;
        grid-row: 2 / 3;
      }
      .capacity {
        grid-column: 1 / 2;
        grid-row: 2 / 3;
        justify-self: center;
        display: flex;
        flex-direction: column;
        align-items: center;
        img {
          height: 1em;
        }
      }
      .name {
        grid-column: 2 / 3;
        grid-row: 1;
        font-weight: 700;
      }
      .capacity-progress {
        align-self: center;
        grid-column: 1 / 3;
        grid-row: 3;
        height: .5em;
        width: 100%;
        background-color: $blue-medium;
        border-radius: 1em;
        padding: 0 .1em;
        display: flex;
        align-items: center;
        & > div {
          height: 70%;
          border-radius: inherit;
          background-color: white;
          border: 1px solid inherit;
        }
      }
    }
    .badge {
      font-size: 2em;
      justify-self: center;
      grid-column: 1;
      grid-row: 1;
      opacity: .5;
      color: $red;
      &-active {
        color: $success;
        opacity: 1;
      }
    }
    &.displacement-status {
      padding: .2em .8em;
    }
    &.shuttle-driver {
      background-color: $blue-ultra-light;
      color: $white;
      img {
        filter: invert(1);
      }
      strong {
        color: $white;
      }
    }
  }
  .first-col-header {
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;
    height: 100%;
    font-weight: 700;
    color: $red;
    text-transform: uppercase;
    border-right: 1px solid black;
  }
</style>
